Summary: Secure Sockets Layer communications libs & utils
Name: SSLeay
Version: 0.8.1
Release: 4
Source0: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/SSLeay-0.8.1.tar.gz
Source1: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/ssleay-doc-0.tgz
Source2: ftp://ftp.psy.uq.oz.au/pub/Crypto/SSL/SSLeay.doc-1.5.tar.gz
Patch: SSLeay-0.8.1-4.patch
Copyright: Freely distributable
Distribution: Hurricane
Vendor: Erik A. Young
Group: Libraries
Provides: SSL
#Prefix: /usr/local/ssl
URL: http://www.replay.com/redhat/
Icon: ssleay.gif
Packager: R. Benjamin Hochstedler <hochstrb@cs.rose-hulman.edu>
%description
A C library that provides various cryptographic algorithms and protocols,
including DES, RC4, RSA, and SSL.  Includes shared libraries and utils.
The SSLeay Crypto FAQ is at: http://www.psy.uq.oz.au/~ftp/Crypto
Goto the webpage indicated by this rpm's URL for access to some
crypto-enabled applications for redhat linux.

%package devel
Summary: Secure Sockets Layer communications static libs & headers & utils
Group: Development/Libraries
Requires: SSLeay
%description devel
A C library that provides various cryptographic algorithms and protocols,
including DES, RC4, RSA, and SSL.   Includes Static libraries and headers for
development. Patches for many networking apps can be found at:
ftp://ftp.psy.uq.oz.au/pub/Crypto/SSLapps/

%package devel-us
Summary: SSLeay RSAref library for building applications for use in the USA
Group: Development/Libraries
Requires: SSLeay-devel
%description devel-us
This package provides the RSAref library which is not allowed outside of 
the USA but inside the USA it is claimed by RSA to be the only RSA public 
key library that can be used besides BSAFE.  SSLeay-devel's libraries are
compiled without this RSA-approved library, and therefore, RSA-enabled
applications built with it, instead of this library are illegal inside 
the USA.  The library provided by this package must be linked against 
first in order to build legal RSA-enabled applications for the USA. 

%changelog
* Mon Apr 13 1998 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-4
- Disabled relocateable features to wait for multiple prefix support
* Tue Dec 30 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-4
- Fixed file & directory inclusion listings & script syntax errors
* Sun Dec 28 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-4
- Fixed relocateability bugs
* Mon Oct 20 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-3
- Fixed profile.d scripts to be relocateable.
* Thu Oct 2 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-3
- Made packages relocateable
* Sun Sep 28 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-3
- Fixed shared library install & profile.d files. Added devel-us package
* Tue Jul 22 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-2
- Cleaned up installation
* Sun Jul 20 1997 Ben Hochstedler <hochstrb@cs.rose-hulman.edu> 0.8.1-1
- Initial RPM

%prep
%setup -T -b 0
%patch -p1
%setup -T -D -n SSLeay-0.8.1/doc/html -c -a 1
%setup -T -D -n SSLeay-0.8.1/doc/ref -c -a 2
#change the named directory back to what it should be
%setup -T -D -n SSLeay-0.8.1

%build 
perl util/perlpath.pl /usr/bin
make -f Makefile.ssl links
./Configure linux-elf
make clean
make depend

#make the shared libraries
sh shlib/linux.sh

#now we can make the other stuff, and they will be linked to the shared libs
make
make rehash

%install 
make install

VERSION=0.8.1
RELEASE=4
prefix=/usr/local/ssl
docdir=$prefix/doc/SSLeay-$VERSION-$RELEASE
contribdir=$prefix/lib/SSLeay
timesdir=$docdir/times
testdir=$contribdir/test
demosdir=$contribdir/demos
bugsdir=$contribdir/bugs

for dir in $docdir $contribdir $timesdir $testdir $demosdir $bugsdir ; do
  mkdir -p $dir
done

strip $prefix/bin/ssleay

install -d $prefix/man
install -d $prefix/man/man1
install -d $prefix/man/man2
install -d $prefix/man/man3
install -d $prefix/man/man4
install -d $prefix/man/man5
install -d $prefix/man/man6
install -d $prefix/man/man7
install -d $prefix/man/man8
install -d $prefix/man/cat1
install -d $prefix/man/cat2
install -d $prefix/man/cat3
install -d $prefix/man/cat4
install -d $prefix/man/cat5
install -d $prefix/man/cat6
install -d $prefix/man/cat7
install -d $prefix/man/cat8
#install -d $prefix/etc/profile.d

install --strip -m755 libssl.so.$VERSION $prefix/lib
install --strip -m755 libcrypto.so.$VERSION $prefix/lib
(cd /usr/local/ssl/lib; \
	ln -s libssl.so.$VERSION libssl.so; \
	ln -s libcrypto.so.$VERSION libcrypto.so \
)

install -m644 libRSAglue.a $prefix/lib
install -m644 rsaref/rsaref.h $prefix/include

install -m755 ssl.csh /etc/profile.d
install -m755 ssl.sh /etc/profile.d

install COPYRIGHT $docdir
install HISTORY $docdir
install HISTORY.066 $docdir
install INSTALL $docdir
install PROBLEMS $docdir
install README $docdir
install README.066 $docdir
install README.080 $docdir
install TODO $docdir
install VERSION $docdir

cd test
cp *.c Makefile *.cnf *.pem certCA.srl tcrl test.txt testca testenc testgen \
 testss testssl tpkcs7* tr* tsid tx509 $testdir
cd ..

for dir in doc bugs demos times ; do
  eval instdir=\$${dir}dir
  install -d $instdir
  cd $dir
  tar cf - . | (cd $instdir ; tar xvf - )
  cd ..
done

cp ssl/readme $docdir/README.SSL

%files
%dir /usr/local/ssl
%dir /usr/local/ssl/doc
%dir /usr/local/ssl/doc/SSLeay-0.8.1-4
%docdir /usr/local/ssl/doc/SSLeay-0.8.1-4
/usr/local/ssl/doc/SSLeay-0.8.1-4/COPYRIGHT
/usr/local/ssl/doc/SSLeay-0.8.1-4/PROBLEMS
/usr/local/ssl/doc/SSLeay-0.8.1-4/README
/usr/local/ssl/doc/SSLeay-0.8.1-4/README.SSL
/usr/local/ssl/doc/SSLeay-0.8.1-4/API.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/a_verify.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/apps.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ca.1
/usr/local/ssl/doc/SSLeay-0.8.1-4/legal.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ms3-ca.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ns-ca.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/readme
/usr/local/ssl/doc/SSLeay-0.8.1-4/ref.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/req.1
/usr/local/ssl/doc/SSLeay-0.8.1-4/s_mult.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ssl-ciph.doc
/usr/local/ssl/man
/usr/local/ssl/private
/usr/local/ssl/certs
/usr/local/ssl/bin
%dir /usr/local/ssl/lib
/usr/local/ssl/lib/libcrypto.so.0.8.1
/usr/local/ssl/lib/libssl.so.0.8.1
%config /usr/local/ssl/lib/ssleay.cnf
/etc/profile.d/ssl.csh
/etc/profile.d/ssl.sh

%files devel
%docdir /usr/local/ssl/doc/SSLeay-0.8.1-4
/usr/local/ssl/doc/SSLeay-0.8.1-4/HISTORY
/usr/local/ssl/doc/SSLeay-0.8.1-4/HISTORY.066
/usr/local/ssl/doc/SSLeay-0.8.1-4/INSTALL
/usr/local/ssl/doc/SSLeay-0.8.1-4/PROBLEMS
/usr/local/ssl/doc/SSLeay-0.8.1-4/README.066
/usr/local/ssl/doc/SSLeay-0.8.1-4/README.080
/usr/local/ssl/doc/SSLeay-0.8.1-4/TODO
/usr/local/ssl/doc/SSLeay-0.8.1-4/VERSION
/usr/local/ssl/doc/SSLeay-0.8.1-4/asn1.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/bio.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/blowfish.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/bn.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/callback.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/cipher.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/cipher.m
/usr/local/ssl/doc/SSLeay-0.8.1-4/conf.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/danger
/usr/local/ssl/doc/SSLeay-0.8.1-4/des.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/digest.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/encode.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/envelope.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/error.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/idea.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/lhash.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/md2.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/md5.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/memory.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/obj.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/rand.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/rc2.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/rc4.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/rsa.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/session.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/sha.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/speed.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ssl.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ssl_ctx.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ssleay.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/ssluse.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/stack.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/threads.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/txt_db.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/verify
/usr/local/ssl/doc/SSLeay-0.8.1-4/why.doc
/usr/local/ssl/doc/SSLeay-0.8.1-4/html
/usr/local/ssl/doc/SSLeay-0.8.1-4/ref
/usr/local/ssl/doc/SSLeay-0.8.1-4/times
/usr/local/ssl/lib/SSLeay
/usr/local/ssl/lib/libcrypto.so
/usr/local/ssl/lib/libcrypto.a
/usr/local/ssl/lib/libssl.so
/usr/local/ssl/lib/libssl.a
/usr/local/ssl/include

%files devel-us
%docdir /usr/local/ssl/doc/SSLeay-0.8.1-4
/usr/local/ssl/lib/libRSAglue.a
/usr/local/ssl/doc/SSLeay-0.8.1-4/rsaref.doc

%post
#Set the RPM_INSTALL_PREFIX manually until spec is updated to support
#multiple prefixes
RPM_INSTALL_PREFIX=/usr/local/ssl

notroot=0
if [ "${RPM_INSTALL_PREFIX}" != "" ] ; then
      notroot=1
fi

notusr=0
if [ "${RPM_INSTALL_PREFIX}" != "/usr" ] ; then
  notusr=1
fi

if [ $notroot -eq 1 ] ; then
  if [ $notusr -eq 1 ] ; then
    echo "MANPATH ${RPM_INSTALL_PREFIX}/man" >> /etc/man.config
    echo "MANPATH_MAP ${RPM_INSTALL_PREFIX}/bin ${RPM_INSTALL_PREFIX}/man" >> \
      /etc/man.config
    
    echo "Adding ${RPM_INSTALL_PREFIX}/lib to /etc/ld.so.conf"
    echo "${RPM_INSTALL_PREFIX}/lib" >> /etc/ld.so.conf
  fi
fi

if [ $notusr -eq 1 ] ; then
  echo "Adding a link in /usr/doc to\
    ${RPM_INSTALL_PREFIX}/doc/SSLeay-0.8.1-4"
  ln -s ${RPM_INSTALL_PREFIX}/doc/SSLeay-0.8.1-4 /usr/doc/SSLeay-0.8.1-4
fi

echo "Running ldconfig"
ldconfig

%post devel
echo "If you intend to build RSA-enabled applications for use in the USA,"
echo "you should install the SSLeay-devel-us-0.8.1-4 package."

%post devel-us
echo "Please read /usr/doc/SSLeay-0.8.1-4/rsaref.doc. It contains\
 important"
echo "information concerning building applications for use in the USA."

%preun
#Set the RPM_INSTALL_PREFIX manually until spec is updated to support
#multiple prefixes
RPM_INSTALL_PREFIX=/usr/local/ssl

echo "Removing links created by ld.so"
rm -f ${RPM_INSTALL_PREFIX}/lib/libcrypto.so.0
rm -f ${RPM_INSTALL_PREFIX}/lib/libssl.so.0

%postun
#Set the RPM_INSTALL_PREFIX manually until spec is updated to support
#multiple prefixes
RPM_INSTALL_PREFIX=/usr/local/ssl

notroot=0
if [ "${RPM_INSTALL_PREFIX}" != "" ] ; then
      notroot=1
fi

notusr=0
if [ "${RPM_INSTALL_PREFIX}" != "/usr" ] ; then
  notusr=1
fi

if [ $notroot -eq 1 ] ; then
  if [ $notusr -eq 1 ] ; then
    echo "Removing \"${RPM_INSTALL_PREFIX}/lib\" entry from /etc/ld.so.conf"
    cp -f /etc/ld.so.conf /etc/ld.so.conf.rpmsave
    grep -v ${RPM_INSTALL_PREFIX} /etc/ld.so.conf.rpmsave > /etc/ld.so.conf
    
    echo "Removing \"${RPM_INSTALL_PREFIX}/man\" entries from /etc/man.config"
    cp -f /etc/man.config /etc/man.config.rpmsave
    grep -v ${RPM_INSTALL_PREFIX} /etc/man.config.rpmsave > /etc/man.config
  fi
fi

if [ $notusr -eq 1 ] ; then
  echo "Removing symbolic link, /usr/doc/SSLeay-0.8.1-4"
  rm -f /usr/doc/SSLeay-0.8.1-4
fi

echo "Running ldconfig"
ldconfig

%verifyscript
#Set the RPM_INSTALL_PREFIX manually until spec is updated to support
#multiple prefixes
RPM_INSTALL_PREFIX=/usr/local/ssl

notroot=0
if [ "${RPM_INSTALL_PREFIX}" != "" ] ; then
      notroot=1
fi

notusr=0
if [ "${RPM_INSTALL_PREFIX}" != "/usr" ] ; then
  notusr=1
fi

if [ $notroot -eq 1 ] ; then
  if [ $notusr -eq 1 ] ; then
    for n in man bin ; do
      echo -n "Looking for \"${RPM_INSTALL_PREFIX}/${n}\" entry in /etc/man.config..."
      if test `grep ${RPM_INSTALL_PREFIX}/${n} /etc/man.config | wc -l` -gt 0 ; then
	echo "found."
      else
	echo "missing."
	echo "\"${RPM_INSTALL_PREFIX}/${n}\" entry in /etc/man.config is missing." >&2
      fi
    done
    
    echo -n "Looking for \"${RPM_INSTALL_PREFIX}/lib\" entry in /etc/ld.so.conf..."
    if test `grep "${RPM_INSTALL_PREFIX}/lib" /etc/ld.so.conf | wc -l` -gt 0 ; then
      echo "found."
    else
      echo "missing."
      echo "\"${RPM_INSTALL_PREFIX}/lib\" entry in /etc/ld.so.conf is\
       missing." >&2
    fi
  fi
fi

if [ $notusr -eq 1 ] ; then
  echo -n "Checking for the symbolic link, /usr/doc/SSLeay-0.8.1-4..."
  if test -L /usr/doc/SSLeay-0.8.1-4 ; then
    echo "found."
  else
    echo "missing."
    echo "Symbolic link /usr/doc/SSLeay-0.8.1-4 is missing." >&2
  fi
fi
